;***************************************************************
;*         aPLib v0.17b  -  the smaller the better :)          *
;*                  NASM assembler depacker                    *
;*                                                             *
;*    Copyright (c) 1998 by  Jibz  All Rights Reserved     *
;*    -> NASM     Archee/CoNTRACT (soltesz@hotmail.com)        *
;***************************************************************

section .text use32

global _aP_depack_asm

_aP_depack_asm:
    push   ebp
    mov    ebp, esp
    pushad
    push   ebp

    mov    esi, [ebp + 8]     ; C calling convention
    mov    edi, [ebp + 12]

    cld
    mov    dl, 80h

literal:
    movsb
nexttag:
    call   getbit
    jnc    literal

    call   getbit
    jnc    codepair
    call   getbit
    jnc    shortmatch
    xor    eax, eax
    xor    ecx, ecx
    mov    cl, 4
getmorebits:
    call   getbit
    adc    eax, eax
    loop   getmorebits
    jnz    domatch_with_inc
    stosb
    jmp    short nexttag
codepair:
    call   getgamma
    dec    ecx
    loop   normalcodepair
    mov    eax,ebp
    call   getgamma
    jmp    short domatch

normalcodepair:
    xchg   eax, ecx
    dec    eax
    shl    eax, 8
    lodsb
    mov    ebp, eax
    call   getgamma
    cmp    eax, 1280
    jb     not_gt_1280
    inc    ecx
not_gt_1280:
    cmp    eax, BYTE 7fh
    ja     domatch
    inc    ecx
    jmp    short domatch_with_inc

shortmatch:
    xor    eax, eax
    lodsb
    xor    ecx, ecx
    shr    eax, 1
    jz     donedepacking
    adc    ecx, BYTE 1
    mov    ebp, eax

domatch_with_inc:
    inc    ecx
domatch:
    push   esi
    mov    esi, edi
    sub    esi, eax
    rep    movsb
    pop    esi
    jmp    short nexttag

getbit:
    add     dl, dl
    jnz     stillbitsleft
    mov     dl, [esi]
    inc     esi
    adc     dl, dl
stillbitsleft:
    ret

getgamma:
    xor    ecx, ecx
    inc    ecx
getgammaloop:
    call   getbit
    adc    ecx, ecx
    call   getbit
    jc     getgammaloop
    ret

donedepacking:
    pop    ebp
    sub    edi, [ebp + 12]
    mov    [ebp - 4], edi     ; return unpacked length in eax

    popad
    pop    ebp
    ret
